/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using System;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.Events;namespace PluginIdea.ContexMenuSystem{    public class SettingModule : CMModuleBase    {        private JSONStorableBool showOutLine;        private JSONStorableBool showHitNormal;        private JSONStorableBool selectAtomWhenAdded;        private JSONStorableBool autoFocusWhenAdded;        private JSONStorableFloat fullscreenWidth, fullscreenHeight;        public SettingModule(ContexMenuSystem ower)        {            this.ower = ower;        }        public override void Init()        {            Utils.SetupInfoTextNoScroll(ower, "<size=35><b>Global Setting</b></size>\n\n", 40, false);            fullscreenWidth = Utils.SetupSliderInt(ower, "FullScreen Width", 1920, 720, 8192, false);            fullscreenWidth.setCallbackFunction = (val) => { GlobalSetting.Resolution.x = (int)val; };            fullscreenHeight = Utils.SetupSliderInt(ower, "FullScreen Height", 1080, 480, 4096, false);            fullscreenHeight.setCallbackFunction = (val) => { GlobalSetting.Resolution.y = (int)val; };            showOutLine = Utils.SetupToggle(ower, "Show OutLine When Hoved", true, false);            showOutLine.setCallbackFunction = (val) => { GlobalSetting.showOutLine = val; };            selectAtomWhenAdded = Utils.SetupToggle(ower, "Select Atom When Added", true, false);            selectAtomWhenAdded.setCallbackFunction = (val) => { GlobalSetting.selectAtomWhenAdded = val; };            autoFocusWhenAdded = Utils.SetupToggle(ower, "Auto Focus When Selected", false, false);            autoFocusWhenAdded.setCallbackFunction = (val) => { GlobalSetting.autofocusWhenSelected = val; };                    }        public override void OnReApplyUIParameter()        {        }        public override void OnUpdate()        {        }        public override void UnInit()        {        }    }}