/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using UnityEngine.EventSystems;using System.Linq;namespace PluginIdea.ContexMenuSystem{                                                    public class PersonClothShowHideOpt : OptBase    {        private static List<DAZClothingItem> activeClothItems;        private DAZCharacterSelector dazcharacterSelector;        public PersonClothShowHideOpt(CheckInfo checkInfo) : base(checkInfo)        {        }        public override void Proccess()        {            Debug.Log("Coloth ShowHide");            JSONStorable storableByID = (checkInfo.target as Atom).GetStorableByID("geometry");            if (storableByID != null)            {                dazcharacterSelector = storableByID as DAZCharacterSelector;                bool ishide = (bool)checkInfo.extra;                ShowHideAllCloth(ishide);            }        }        public void ShowHideAllCloth(bool isActive)        {            if (isActive)            {                if (activeClothItems != null && activeClothItems.Count > 0)                {                    activeClothItems.ForEach(item => {                        dazcharacterSelector.SetActiveClothingItem(item, isActive);                    });                }            }            else            {                                var clothItems = dazcharacterSelector.clothingItems;                activeClothItems = clothItems.ToList().Where(x => x.active).ToList();                for (int i = 0; i < activeClothItems.Count; i++)                {                    dazcharacterSelector.SetActiveClothingItem(activeClothItems[i], isActive);                }            }        }    }    public class PersonResetOpt : OptBase    {        public PersonResetOpt(CheckInfo checkInfo) : base(checkInfo)        {        }        public override void Proccess()        {            Atom atom = checkInfo.target as Atom;            switch ((string)checkInfo.extra)            {                case CommandConsts.PersonMenuPhysics_ResetPose: atom.ResetPhysical(); break;                case CommandConsts.PersonMenuPhysics_PhysicsExplosionRecovery: atom.ResetPhysics(); break;                default:                    break;            }        }    }}